import os, struct

def unpack():
    with open('ULJS00190.bin', 'rb') as f:
        filedata = f.read()
    pos = 0x1628b8 #This is where the 2nd pointer address of TOC but it points to 1st pmf file
    with open('movie.bin', 'rb') as f:
        for x in range(13):
            if x == 12:
            	pos = 0x1628b0  #the last pmf file pointer is located at the beginning of TOC
            	datapos = (struct.unpack('<I', filedata[pos+4:pos+8])[0] - 0x48650) * 0x800
            	datalen = struct.unpack('<I', filedata[pos:pos+4])[0]
            	pos += 0x8
            	filename = 'intro.pmf'
            	print('{:2d}'.format(x), '{:8s}'.format(hex(datapos)),
            		'{:7s}'.format(hex(datalen)),
            		datalen // 0x800 + 1, hex(pos - 0x8))
            	f.seek(datapos)
            	with open(filename, 'wb') as g:
            		g.write(f.read(datalen))
            	exit()
            datapos = (struct.unpack('<I', filedata[pos+4:pos+8])[0] - 0x48650) * 0x800
            datalen = struct.unpack('<I', filedata[pos:pos+4])[0]
            pos += 0x8
            filename = '{:0>2}.pmf'.format(x)
            print('{:2d}'.format(x), '{:8s}'.format(hex(datapos)),
                  '{:7s}'.format(hex(datalen)),
                  datalen // 0x800 + 1, hex(pos - 0x8))
            f.seek(datapos)
            with open(filename, 'wb') as g:
                g.write(f.read(datalen))

def pack():
    BASE_POS = 0x47E70   #ISO LBA address of movie.bin
    FAT = []
    with open('movie.bin', 'wb') as f:
    	for x in range(13):
        	if x == 12:   #The intro movie is located at end file but first in TOC
        		filename = 'intro.pmf'
        		with open(filename, 'rb') as g:
        			print(filename)
        			FAT.insert(0,(os.path.getsize(filename), BASE_POS + f.tell() // 0x800)) #update TOC and insert it to the beginning of TOC
        			f.write(g.read())
        	else:
        		filename = '{:0>2d}.pmf'.format(x)
        		with open(filename, 'rb') as g:
        			print(filename)
        			data = g.read()
        		FAT.append((os.path.getsize(filename), BASE_POS + f.tell() // 0x800))
        		f.write(data)
    return FAT
